<%

' ASP Code Created By: Brian Taylor
' email: littlemojo@planetquake.com

on error resume next
%>

<HTML>
<head>


<%
	dim BQServer, hostIP, hostPort, Password, mapname, fraglimit
	dim timelimit, hostname, maxclients, Server_Return, temper

	set BQServer = Server.CreateObject("BQServer.Quake")
	

' This Function adds font tags to the colors in the name

	Function Cleanup(CleanedUser)

		CleanedUser = Replace(CleanedUser,"^0","<Font color=black>")
		CleanedUser = Replace(CleanedUser,"^1","<Font color=red>")
		CleanedUser = Replace(CleanedUser,"^2","<Font color=green>")
		CleanedUser = Replace(CleanedUser,"^3","<Font color=yellow>")
		CleanedUser = Replace(CleanedUser,"^4","<Font color=blue>")
		CleanedUser = Replace(CleanedUser,"^5","<Font color=cyan>")
		CleanedUser = Replace(CleanedUser,"^6","<Font color=magenta>")
		CleanedUser = Replace(CleanedUser,"^7","<Font color=white>")

		CleanedUser = Replace(CleanedUser,"<Font color=","</FONT><Font color=")


		CleanedUser = CleanedUser & "</FONT>"

		CleanedUser = Replace(CleanedUser,"</FONT>","", 1, 1)

		Cleanup = CleanedUser

	End Function


' You Must Enter a Real IP, Port, and Rcon Password for this to work

	hostIP = "192.168.123.35"
	hostPort = "27960"
	Password = "homer1"
	SVTimeOut = 4
	SVDelay = 0.5


' This Function checks to see if the server exists

	Function ServerTimeOut(Message)
	
		if Message = "BQServer Error: Server Timed Out" or Message = "" or Left(Message, 17) = "Bad rconpassword." then
			response.write "<CENTER><BR><FONT SIZE=1>" & Now() & "</FONT><BR><FONT size=2 FACE='ARIAL'>The Quake3 server is currently down... Please try again later."
			response.write "<BR><BR>Also, the Quake server may have been too overloaded with messages.<BR>Please try not to refresh your browser too fast."
			Response.Write "<BR><A HREF='quake3_alt.asp'>-Refresh Page-</A>"
			response.write "</BODY></HTML>"
			ServerTimeOut = "BQServer Error: Server Timed Out"
			response.end
		else
			ServerTimeOut = Message
		end if
		
	End Function


' This Function can pull multiple server variables from one server message "serverinfo"
' This was done to lessen the number of messages sent to the quake3 server

' Variables available are:
' g_needpass, gamename, bot_minplayers, sv_allowdownload, sv_privateClients, mapname
' protocol, g_gamename, version, g_maxGameClients, capturelimit, sv_floodProtect, sv_maxRate
' sv_maxclients, sv_hostname, timelimit, fraglimit, dmflags, sv_minPing, sv_maxPing

	Private Function F_ServerInfo(LookUp)
	
		F_ServerInfo_Result1 = Instr(1, serverinfo, LookUp, 1)
		F_ServerInfo_Result2 = Instr(F_ServerInfo_Result1, serverinfo, Chr(10), 1)
		F_ServerInfo = Mid(serverinfo, (F_ServerInfo_Result1 + 20), ((F_ServerInfo_Result2 - 1) - (F_ServerInfo_Result1 + 20)))
	
	End Function


' These temp files contain the raw returned strings from the server

	serverinfo = ServerTimeOut(BQServer.Server_Rcon("serverinfo", hostIP, hostPort, Password, SVTimeOut, SVDelay))	
	Server_Return = ServerTimeOut(BQServer.Server_Rcon("status", hostIP, hostPort, Password, SVTimeOut, SVDelay))


' The temp files are then cleaned up, and only the needed data is left.

	gamename = F_ServerInfo("gamename")
	mapname = F_ServerInfo("mapname")
	fraglimit = F_ServerInfo("fraglimit")
	timelimit = F_ServerInfo("timelimit")
	sv_hostname = F_ServerInfo("sv_hostname")
	sv_maxclients = F_ServerInfo("sv_maxclients")
	g_gametype = F_ServerInfo("g_gametype")


' This chooses the friendly name for the Quake3 game types

	Select Case g_gametype
		Case "0"
			g_gametype = "Free For All"
		Case "1"
			g_gametype = "Tournament 1-on-1"
		Case "2"
			g_gametype = "Single-Player"
		Case "3"
			g_gametype = "Team Deathmatch"
		Case "4"
			g_gametype = "Capture the Flag"
	End Select




' This removes the first 3 lines of the Server_Return data containing "status"

	LeftCount = (Instr(1, Server_Return, "---------------------", 1))+33

	Server_Return_Trim = Right(Server_Return, (Len(Server_Return)-LeftCount))

	Server_Return_Trim = Left(Server_Return_Trim, Len(Server_Return_Trim)-2)



' This counts the players connected by counting the number of charaters in the string. A half-assed approach indeed.

	PlayersOn = Int(Len(Server_Return_Trim)/73)


%>

<title><%=PlayersOn%> Players Connected to <%=sv_hostname%></title>
</head>

<BODY bgcolor="#00125B" topmargin="4" leftmargin="3" text="#FFFFFF" vlink="#FFFFFF" alink="#FFFFFF">


<CENTER>

<TABLE border=0 width=100% cellspacing=0 cellpadding=0>
<TR><TD>
<CENTER>

<TABLE width="97%" border=1 cellspacing=0 cellpadding=0 bordercolor="#526096">
<TR><TD bgcolor="#334071"><CENTER><Font Size=2 Face="Arial"><b><%=Cleanup(sv_hostname)%></b></FONT></TD></TR>
<TR><TD bgcolor='#00104F'><CENTER><Font size=1 Face='Arial'>- <%=g_gametype%> -</FONT></TD></TR>
</TABLE>
<HR color="#334071" size="1">

</TD></TR>

<TR><TD><CENTER>

	<TABLE border=1 cellspacing=0 cellpadding=0 bordercolor="#526096">
	<TR><TD bgcolor="#334071"><IMG SRC="quake3/baseq3/images/<%=mapname%>.jpg" width="110" height="82"></TD></TR>
	<TR><TD bgcolor="#334071"><CENTER><Font size=1 Face='Arial'><%=mapname%></FONT></TD></TR>
	</TABLE>
<HR color="#334071" size="1">
</TD></TR>
<TR>
<TD>
<CENTER>

	<TABLE width=96% border=1 cellspacing=0 cellpadding=0 bordercolor="#526096">
	<TR><TD width="90%" bgcolor="#334071"><Font size=1 Face='Arial'><B>Players: <%=PlayersOn%>/<%=sv_maxclients%></B></TD><TD width="10%" bgcolor="#334071"><Font size=1 Face='Arial'><B>Score</B></TD></TR>


<%

' This generate the player names and scores from Server_Return_Trim

	LastTrim = 1

	Trims = 1

	While Trims <> 0

		StartTrim = StartTrim + 74

		Trims = Instr(StartTrim, Server_Return_Trim, Chr(10))


		if Trims <> 0 then


			TrimTemp = Mid(Server_Return_Trim, LastTrim, (Trims-LastTrim)-1)

			UserName = Trim(Mid(TrimTemp, 17, 16+((Trims-LastTrim)-74)))


			Score = Trim(Mid(TrimTemp, 6, 5))


			response.write "<TR><TD bgcolor='#00104F'><Font size=1 Face='Arial'><B>" & Cleanup(UserName) & "<B></FONT></TD><TD bgcolor='#00104F' align=center><Font Face='Arial' Size=1>" &  Score & "</FONT></TD></TR>" & Chr(10)

			LastTrim = Trims


		end if

	wend
%>


	<TR><TD bgcolor="#334071" colspan="2"><CENTER><Font size=1><%=Time()%></FONT></CENTER></TD>

	</TR>
	</TABLE>



</TD>
</TR>
</TABLE>

<META HTTP-EQUIV="REFRESH" CONTENT="30; URL=quake3_alt.asp">

</BODY>
</HTML>